Subject: Re: [PWE3] MPLS PID

From: Curtis Villamizar <[email-masked]>
Date: Wed, 02 Apr 2003 12:27:08 -0500

In message <[email-masked]>, "
David Allan" writes:
> This message is in MIME format. Since your mail reader does not understand
> this format, some or all of this message may not be legible.
> 
> ------_=_NextPart_001_01C2F938.99B58490
> Content-Type: text/plain;
> 	charset="iso-8859-1"
> 
> Curtis:
> 
> 
> > I never knew that MPLS architecture was a religion.  I always 
> > thought MPLS was deployed and because it solved real world 
> > practical problems.
> 
> The above seems to be orthogonal to the discussion at hand :-(

Very much like the statements you made regarding "violating the MPLS
architecture", including the one I quoted that you omited.

> > Requiring the martinni control word would seem like a no 
> > brainer. However maybe we don't buy into that for some 
> > **technical** reason, perhaps overhead on the control word in 
> > the edge of the network makes a difference.  If so, then the 
> > control word must be added along the way if the traffic type is known.
> 
> My comment was more along the lines that if we accept ECMP as defacto, then
> we have more to do than simply making sure PWs do not occasionally re-order.
> IMHO it may solve some problems but would still be a major obstacle to
> solving others.

The martinni control word is one complete solution.  The only possible
objection is the added overhead.

> > The only truly deterministic way to know the traffic type is 
> > if L3PID tells you.  
> 
> Yes, but as you note, that information is on a need to know basis and you
> still end up inserting a dummy control word for those folks in the core that
> will not be privy to this information. The core still expects stuff to self
> identify.
> 
> BTW I presume you're exclusively discussing TE L3PID?
> 
> cheers
> Dave

Yes I mean the TE L3PID.  And the same is needed for LDP.

As I said (which you omitted), the easiest solution is requiring that
the martinni control word be implemented but making its use optional.

A more complete solution would involve using the L3PID, essentially
signaling whether the traffic within an LSP was 1) all IP, 2) a mix of
IP and not IP with control word, or 3) not IP with no control word, or
4) a mix of IP and not IP with no control word.  For the first two
ECMP is possible.  The third can be mixed with IP if a control word
indicating "non-IP of unknown type" is added, then removed at egress.
For the last set ECMP can't be used without risking reorder.  There is
also the value of L3PID of MPLS which indicates that there is no clue
what is contained in the LSP and the LSR has to be configured to
either "make a guess" (which ISPs will configure if they are using IP
and non-IP with control word) or to not do ECMP.

Curtis